#include <avr/io.h>
#include <stdlib.h>
#include <string.h>
#include <avr/interrupt.h>
#define F_CPU 8000000
#include <util/delay.h>
#include <avr/pgmspace.h>

#include "main.h"
#include "globals.h"
#include "owxx.h"

#define main_lcd 0

#if main_lcd
#define true 1
#define false 0
#define NULL 0
#include "C:\zuc\lcd\colors.h" //C:\WinAVRkk\kklibx\//
#define i2c_ds1307 1
#include "C:\zuc\i2c\twimaster.h"
#include "C:\zuc\i2c\kk_twixx.h"
#define use_glcd     	0
#include "C:\zuc\lcd\twilcd.h" //C:\WinAVRkk\kklibx\//
#include "C:\zuc\lcd\lcd_std_func.h" //C:\WinAVRkk\kklibx\//
#endif


void init_timer_smh() {
/*
cs02+01+00:
0 no clock
1 no presc
2 /8
3 /64
4 /256
5 /1024
*/

TCCR0A |= (1<<WGM01);
    // 1; Timer0 Vorteiler: 64 -> bei 16 MHz: 
    // 16.000.000 / 64 = 250000 Mal pro Sek gibts einen Takt an den Timer
    // 8.000.000 / 1024 = 7812 Mal pro Sek gibts einen Takt an den Timer
TCCR0B |= ((1<<CS02)|(1<<CS00));//1024
    
    // Timer0 soll bei 250 einen Output Compare Interrupt ausl?sen ->
    // 250.000 / 250 = 1000 mal pro Sek gibts einen Interrupt
    // 7812 /78 = 100 mal pro Sek gibts einen Interrupt
OCR0A = 77;//abgleich mit uhr

    //Compare Interrupt aktivieren
TIMSK0 |= (1<<OCIE0A);

    //Globale Interrupts aktivieren
sei();
}

//===========================================================
void timer_proc_10ms(void){
//led1_tog;
timer_smh++;
timer_10ms++;


}
//===========================================================


ISR(TIMER0_COMPA_vect)
{
timer_proc_10ms();
}

//================================================

void main(void){
uint8_t ret;
uint8_t min_alt,sec_alt;
  //
led1_init;
init_timer_smh();
owx_init();



while(1) {

//+++++++++++++ polling +++++++++++++
if(owx_signal){
//led1_on;
#if owx_slave
sub_owx_polling_10();
#endif
#if owx_master
sub_owx_polling_88();
#endif
}
//------------- polling -------------




	  
//++++++++++++ volleSecunde ++++++++++++++++++++++
if(timer_smh>100){//1sec
//	led1_tog;
	sec=sec+timer_smh/100;
	timer_smh=timer_smh%100;
	if(sec>59){sec=sec-60;	min++;
	if(min==60){min=0; hou++;
	if(hou==24){hou=0;}}}
}//1sec

if(sec!=sec_alt ){
#if main_lcd
lcd_time();
#endif
#if  owx_lcd
owx_lcd_time();
#endif


//owx_lcdx();

	sec_alt=sec;
	if(owx_value)led1_off;//else led1_on;


	#if owx_master
	//jede Minute sync time
	if(sec%15==3 && owx_status != owx_status_refreshed){
		ret=	sub_owx_transfer_88(10,20,20,0);
		if(ret)owx_status=owx_status_error;
	}
	#endif

	//++++++++++++ volle Minute ++++++++++++++++++++++
	if(min!=min_alt){
	owx_status = owx_status_waitfordata; 
	owx_tx_buffer[6]=hou;
	owx_tx_buffer[7]=min;
	owx_tx_buffer[8]=sec;
	
	
	min_alt=min;
	}

	  
}//sc_alt	  
}//while(1)
	
}

