#include <avr/io.h>
#include <stdlib.h>
#include <string.h>
#define F_CPU 8000000
#include <util/delay.h>
#include "globals.h"
#include "owxx.h"

//===========================================================
uint8_t owx_tx_buffer[30]={'A','B','C','D','E','F','G','H','I','J'};
uint8_t owx_rx_buffer[30]={0,1,2,3,4,5,6,7,8,9,0,1,2,3,4,5,6,7,8,9};
//u8 *owx_tx8=(owx_tx_buffer+6);//8bit-Zeiger auf payload
//u8 *owx_rx8=(owx_rx_buffer+6);//8bit-Zeiger auf payload
int16_t *owx_tx16=(owx_tx_buffer+14);//16bit-Zeiger auf payload
int16_t *owx_rx16=(owx_rx_buffer+14);//16bit-Zeiger auf payload

#define owx_tx_header owx_tx_buffer
#define owx_rx_header owx_rx_buffer




#if owx_lcd
#define true 1
#define false 0
#define NULL 0
#include "C:\zuc\lcd\colors.h" 
#define i2c_ds1307 1
#include "C:\zuc\i2c\twimaster.h"
#include "C:\zuc\i2c\kk_twixx.h"
#define use_glcd     	0
#include "C:\zuc\lcd\twilcd.h" 
#include "C:\zuc\lcd\lcd_std_func.h" 
#endif

//-------------------------------------------
void owx_init(void){
	owx_in;
	owxled_init;
	dly_short;
#if owx_lcd
	lcd_init();
	lgw(1,1,"OWXS");
#endif
	control_init;
}




//-------------------------------------------
void owx_tx_byte(u8 dat){
// wenn 1: low - kurz - kurz - high
// wenn 0: low - kurz - high
u8 i;
for(i=0;i<8;i++){
  owx_out_low;
  dly_short;
	  if(dat & 0x80){
		  dly_short;
	  }
  dat = dat<<1;
  owx_out_high;
  dly_short;
  }
}


//-------------------------------------------
u8  owx_rx_byte(void){
u8 dat=0,i=0;
u32 timeout;
for(i=0;i<8;i++){
	timeout=0;
	while(!owx_signal && timeout<100000)timeout++;//warten auf low
	dat=dat<<1;

	dly_med;//nach Eintritt von low dly_med warten
		if(owx_signal){
		//wenn an der Stelle t=dly_med high, dann =>
			dat++;
			dly_short;
			control_high;
		}else{
			control_low;
		}
}
return(dat);
}



//-------------------------------------------
void owx_message_tx(u8 msg){
//besttigung: 2x kurz low
//fehler 1x kurz low

owx_out;
dly_short;
owx_out_low;
dly_short;
	if(msg){
	  dly_short;
	  }
owx_out_high;
owx_in;
}


//-------------------------------------------
u8 owx_message_rx(void){
//messen, ob Besttigung 1xkurz oder 2xkurz

owx_in;
u8 erg;
u32 timeout,messwert=0;
timeout=0;
while(!owx_signal && timeout<100000)timeout++;//warten auf low
while(owx_signal && messwert<100000)messwert++;//messen low

erg=(messwert+50)/100;//250-349

//lgi(3,1,timeout);lw(":");li(messwert);lw("=");li(erg);
//lgi(4,1,erg);lw(" ");
if (erg==3)return (0);//ok
else return (1);//error
}


//---------------------------------------------
u8 owx_senden(  
  u8 *buff  /* Pointer to the data */
  ,u8 btx    /* Number of bytes to send (header+payload) */
//  ,u8 tx0_rx1
){
u8 ret;
u8 crc=0;

owx_out;
owx_out_low;
_delay_ms(200);//Anfangssynchronisierung durch Master
owx_out_high;
dly_short;

do{
  crc=crc+1+*buff;
  owx_tx_byte(*buff++);
  } while (--btx);
owx_tx_byte(crc);
//owxtest=crc;


ret=owx_message_rx();

	if(!ret){//ok
#ifdef lgw
		lgw(1,18,"tok");
#else
owxled_blink_ok;			
#endif			
		return 0;
	}else{
#ifdef lgw
		lgw(1,18,"ter");
#else
owxled_blink_error;			
#endif			
		return 9;
	}
}


//-------------------------------------------
u8 owx_empfangen(  
  u8 *buff    /* Pointer to data buffer */
){
u8 len,adr=0;
u8  crc=0;
//owxled_on;

control_high;
while(owx_signal);//Anfangssynchronisierung durch Master
control_low;

 //adr
  *buff = owx_rx_byte();
  adr=*buff;
// li(adr);
// owxled_off;
  crc=crc+1+*buff;
  *buff++;
 
//len
  *buff = owx_rx_byte();
  len=*buff-2;
  crc=crc+1+*buff;
  *buff++;

//4xheader + payload
do{
  *buff = owx_rx_byte();
  crc=crc+1+*buff;
  *buff++;
  } while (--len);

//crc
  *buff = owx_rx_byte();
u8 crcx=*buff;  
 

control_low;
#if owx_lcd
owx_display_buffer();
#endif

 
//wenn (dest-)adr==owx_my_adr
	if(adr==owx_my_adr){ 
//rx besttigung 
		if(*buff==crc ){
			owx_message_tx(0);
#ifdef lgw
			lgw(1,18,"rok");
#else
owxled_blink_ok;			
#endif			
			return(0);
		}else{
			owx_message_tx(1);
#ifdef lgw
			lgw(1,18,"rer");
#else
owxled_blink_error;			
#endif			
		owx_status=owx_status_error;
			return(1);
		}
	}
return(2);//!= owx_my_adr
	
}

//========================================
void sub_owx_polling_88(void){
///==============Aufruf aus  Hauptschleife =================
u8 ret;
ret=owx_empfangen(owx_rx_buffer);

	if(!ret){
	//... rx-buffer-Werte auslesen
	u16 elt=owx_rx16[0];
	}
}

//================================================
void sub_owx_polling_10(void){
u8 ret;
ret=owx_empfangen(owx_rx_buffer);
	if(!ret){


		if(owx_lenback){
		//header fllen, payload wird in der Anwendung gefllt
		  owx_tx_buffer[0]=owx_rx_buffer[2];//dest_adr
		  owx_tx_buffer[1]=6+owx_lenback;//;//len nur header
		  owx_tx_buffer[2]=owx_my_adr;//source_adr
		  owx_tx_buffer[3]=owx_status_refreshed;//status
		  owx_tx_buffer[4]=0;//start
		  owx_tx_buffer[5]=0;//lenback
		ret=owx_senden(owx_tx_buffer,owx_lenback+6);
		}



		if(owx_status==owx_status_refreshed){
		//payload auswerten
		sec=owx_rx_buffer[6];
		min=owx_rx_buffer[7];
		hou=owx_rx_buffer[8];
//		owx_tx_buffer[6]=sec;//len
//		timer_smh=0;



	//wenn Schaltanweisung, diese abarbeiten
			if(owx_rx_buffer[4]){
				switch (owx_rx_buffer[4])
				{
				  case (1)://hzg ein
	//sub_hzg_manuel_start();
					break;
			  
				  case (2)://hzg aus
	//sub_hzg_manuel_down();
					break;
			   }
			}
		}

	}else{//!ret
		owx_status=owx_status_error;
	}
owxled_off;
}




//===========================================
uint8_t sub_owx_transfer_88(u8 dest, u8 len, u8 lenback, u8 cmd){

u8 ret;
//u8  owx_payload_len=20;

//header fllen
owx_tx_header[0]=dest;//destination_adr
owx_tx_header[1]=len+6;
owx_tx_header[2]=owx_my_adr;//source_adr
owx_tx_header[3]=owx_status_refreshed;//status
owx_tx_header[4]=cmd;//cmd_cmd
owx_tx_header[5]=lenback;//len_back



owx_tx16[0]=444;//=>6+8+0
owx_tx16[1]=555;
owx_tx16[2]=666;
owx_tx16[3]=777;

/*
//payload2 fllen 6x 16bit
owx_tx_buffer[14+0*2]=tr_wzbx;//=>6+8+0
owx_tx_buffer[14+1*2]=tr_aux;
owx_tx_buffer[14+2*2]=tr_wwx;
owx_tx_buffer[14+3*2]=tr_wzlx;
*/

//payload1 fllen 8x 8bit
owx_tx_buffer[6+0]=sec;
owx_tx_buffer[6+1]=min;
owx_tx_buffer[6+2]=hou;
owx_tx_buffer[6+3]=anforderung;

 
ret=owx_senden(owx_tx_buffer,len+6);
return ret;
}

//================ Hilfsdateien ============================



#if owx_lcd
  void  owx_lcd_time(void){
	lcd_goto(1,1);
	lcd_int2( hou);
	lcd_write(":");
	lcd_int2(min);
	lcd_write(":");
	lcd_int2(sec);
  }
 #endif 
  
  
  
void  owx_display_buffer(void){
#if owx_lcd
lg(2,1);
li(owx_rx_buffer[0]);
lw("-");
li(owx_rx_buffer[1]);
lw("-");
li(owx_rx_buffer[2]);
lw("-");
li(owx_rx_buffer[3]);
lw("-");
li(owx_rx_buffer[4]);
lw("-");
li(owx_rx_buffer[5]);

lg(1,10);
li(owx_rx_buffer[8]);
lw(":");
li(owx_rx_buffer[7]);
lw(":");
li(owx_rx_buffer[6]);
lw(" ");



lg(3,1);
li(owx_tx_buffer[0]);
lw("-");
li(owx_tx_buffer[1]);
lw("-");
li(owx_tx_buffer[2]);
lw("-");
li(owx_tx_buffer[3]);
lw("-");
li(owx_tx_buffer[4]);
lw("-");
li(owx_tx_buffer[5]);
lw(" ");
     ;
lg(4,1);
li(owx_tx_buffer[6]);
lw(":");
li(owx_tx_buffer[7]);
lw(":");
li(owx_tx_buffer[8]);
lw(" ");
#endif

    }
  
  


