#ifndef _owx_h
	#define _owx_h

//owx
#define owx_port 		C
#define owx_pin 		1
#define owxled_port 	D
#define owxled_pin 		0
#define owx_slave 		0	//1: m328 als slave 
#define owx_master 		01	//1: m328 als master


#define owx_lcd 0  //1: debug mit grundschler-lcd

//zwecks Darstellung Empfang auf logicanalycer
#define control_init   DDRC|=(1<<2)
#define control_low    PORTC&=~(1<<2)
#define control_high   PORTC|=(1<<2)






#if owx_slave
#define owx_my_adr 10
#endif
#if owx_master
#define owx_my_adr 88
#endif


#define GLUE(a, b)  a##b
#define PORT(x)    			GLUE(PORT, x)
#define PIN(x)    			GLUE(PIN, x)
#define DDR(x)    			GLUE(DDR, x)
#define pinSET(x,y) 		PORT(x) |=(1<<y)
#define pinCLR(x,y) 		PORT(x)&=~(1<<y)
#define pinTOG(x,y) 		PORT(x)^=(1<<y)
#define pinDIRin(x,y) 		DDR(x)&=~(1<<y)
#define pinDIRout(x,y) 		DDR(x)|=(1<<y)
#define pinVAL(x,y) 		(PIN(x)&(1<<y))
#define u8x  uint8_t
#define pinPULLUP(x,y,z) 	(z)?(PORT(x)|=(1<<y)):(PORT(x)&=~(1<<y))//0_no 

#define i8  int8_t
#define i16 int16_t
#define u8  uint8_t
#define u16 uint16_t
#define u32 uint32_t
#define v volatile

#define owxled_tog 	pinTOG(owxled_port,owxled_pin)
#define owxled_on   	pinSET(owxled_port,owxled_pin)
#define owxled_off   	pinCLR(owxled_port,owxled_pin)

#define owxled_blink_error {owxled_tog;_delay_ms(300);owxled_tog;_delay_ms(300);owxled_tog;\
_delay_ms(300);owxled_tog;_delay_ms(300);owxled_tog;_delay_ms(300);owxled_tog;\
		_delay_ms(300);owxled_tog;_delay_ms(300);owxled_off;}

#define owxled_blink_ok {owxled_tog;_delay_ms(1000);owxled_tog;_delay_ms(300);}

#define owxled_init 	pinDIRout(owxled_port,owxled_pin);owxled_blink_error;


//owx-defines
#define owx_out pinDIRout(owx_port,owx_pin);pinCLR(owx_port,owx_pin)
#define owx_in   pinDIRin(owx_port,owx_pin);pinPULLUP(owx_port,owx_pin,1)
#define owx_value      pinVAL(owx_port,owx_pin)
#define owx_signal      !(pinVAL(owx_port,owx_pin))
#define owx_out_high  pinSET(owx_port,owx_pin)
#define owx_out_low    pinCLR(owx_port,owx_pin)
#define ERROR       return(0xffff);
#define dly_short     _delay_us(400)
#define dly_med       _delay_us(600)//1,5
#define owx_READ      1
#define owx_WRITE     0

#define owx_status     owx_rx_buffer[3]
#define owx_lenback    owx_rx_buffer[5]
#define owx_status_refreshed     	10
#define owx_status_error       		98
#define owx_status_waitfordata     	99

void  owx_display_buffer(void);
void owx_lcd_time(void);


void owx_init(void);
void sub_owx_polling_10(void);
void sub_owx_polling_88(void);
uint8_t sub_owx_transfer_88(uint8_t dest, uint8_t len, uint8_t lenback,uint8_t cmd);


/**/

#endif
